<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleAvailRQCoreTypeVehPref ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleAvailRQCoreTypeVehPref extends AbstractStructArrayBase
{
    /**
     * The VehPref
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref[]
     */
    public $VehPref;
    /**
     * Constructor method for ArrayOfVehicleAvailRQCoreTypeVehPref
     * @uses DgArrayOfVehicleAvailRQCoreTypeVehPref::setVehPref()
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref[] $vehPref
     */
    public function __construct(array $vehPref = array())
    {
        $this
            ->setVehPref($vehPref);
    }
    /**
     * Get VehPref value
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref[]|null
     */
    public function getVehPref()
    {
        return $this->VehPref;
    }
    /**
     * Set VehPref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref[] $vehPref
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeVehPref
     */
    public function setVehPref(array $vehPref = array())
    {
        foreach ($vehPref as $arrayOfVehicleAvailRQCoreTypeVehPrefVehPrefItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleAvailRQCoreTypeVehPrefVehPrefItem instanceof \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref) {
                throw new \InvalidArgumentException(sprintf('The VehPref property can only contain items of \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref, "%s" given', is_object($arrayOfVehicleAvailRQCoreTypeVehPrefVehPrefItem) ? get_class($arrayOfVehicleAvailRQCoreTypeVehPrefVehPrefItem) : gettype($arrayOfVehicleAvailRQCoreTypeVehPrefVehPrefItem)), __LINE__);
            }
        }
        $this->VehPref = $vehPref;
        return $this;
    }
    /**
     * Add item to VehPref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeVehPref
     */
    public function addToVehPref(\dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref) {
            throw new \InvalidArgumentException(sprintf('The VehPref property can only contain items of \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehPref[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVehPref|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehPref
     */
    public function getAttributeName()
    {
        return 'VehPref';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeVehPref
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
